//sazzad

#include<iostream>
#include<stdio.h>
#include<signal.h>
#include<string.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netinet/tcp.h>


#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include<vector>
#include <sstream>

#define INVALID_SOCKET -1

int GetFileSize(const std::string& sFile){
        struct stat fStat;
        stat( sFile.c_str(), &fStat );
        return fStat.st_size;

return -1;
}


std::string GetDotFormatIP(uint32_t ip){

	struct in_addr addr;
	addr.s_addr = htonl(ip);
	return std::string(inet_ntoa(addr));
}


void reuse(int fd)
{
        int on = 1;
        if (setsockopt(fd, SOL_SOCKET, SO_REUSEADDR, (char *)&on,
                sizeof(on)) != 0)
        {
                perror("SO_REUSEADDR");
        }

#ifdef SO_REUSEPORT
        on = 1;
        if (setsockopt(fd, SOL_SOCKET, SO_REUSEPORT, (char *)&on,
                sizeof(on)) != 0)
        {
                perror("SO_REUSEPORT");
        }
#endif
}

void nonblock(int fd)
{
        int flags = fcntl(fd, F_GETFL, 0);
        flags |= O_NONBLOCK | O_NDELAY;

        if (fcntl(fd, F_SETFL, flags) == -1)
        {
                perror("fcntl");
        }
}

void nodelay(int fd){

         int flag = 1;
         int result = setsockopt(fd,            /* socket affected */
                                 IPPROTO_TCP,     /* set option at TCP level */
                                 TCP_NODELAY,     /* name of option */
                                 (char *) &flag,  /* the cast is historical
                                                         cruft */
                                 sizeof(int));    /* length of option value */
        if (result < 0){
                std::cout<<"Error setting TCP_NODELAY"<<std::endl;
        }

}



void ByteOrderTesting(){

union U{
        char c[4];
        int i;
};

        U a;
        a.i=0x12345678;
        printf("%x: %x: %x: %x", a.c[0], a.c[1], a.c[2], a.c[3]);

        if(a.c[0] == 0x12 )
                printf("big endian\n");
        else
                printf("little endian\n");

}

/* 
 * @param stdoutname If not NULL, stdout and stderr are redirected
 * to this file.
 * @returns -1 if stdoutname could not be opened.  -2 if the fork() fails.
 * Otherwise, 0.
 */
int RunAsDaemon(const char* stdoutname)
{
        int stdoutfd = -1;
        if (stdoutname != NULL)
        {
#ifdef __FreeBSD__
                stdoutfd = open(stdoutname, O_CREAT | O_WRONLY | O_FSYNC, 0777);
#else
                stdoutfd = open(stdoutname, O_CREAT | O_WRONLY | O_SYNC, 0777);
#endif
                if (stdoutfd < 0)
                        return -1;
        }

        int pid = fork();

        if (pid == -1)
                return -2;

        close(0);
        close(1);
        close(2);

        // parent
        if (pid != 0)
        {
                if (stdoutfd != -1)
                        close(stdoutfd);
                return 0;
//              exit(0);
        }

        // child
        if (stdoutfd != -1)
        {
                dup2(stdoutfd, 1);
                dup2(stdoutfd, 2);

                close(stdoutfd);
        }

        return getpid();
//      return 0;
}

int write_pid(const char * sFileName)
{
        FILE *fp;

        if( (fp=fopen(sFileName,"w")) == 0 )
        {
                return -1;
        }
        if( fprintf(fp,"%i\n",getpid()) <=0  )
        {
                fclose(fp);
                return -1;
        }

        fclose(fp);

        return 0;
}


typedef std::pair<uint32_t, uint16_t> AddressPortPair;

AddressPortPair GetSockName(uint32_t sock)
{
        sockaddr_in local;
        memset(&local, 0, sizeof(local));
        local.sin_family = AF_INET;

        int iLen = sizeof(local);
        u_int32_t uAddr = 0;
        u_int16_t uPort = 0;

        if (INVALID_SOCKET != sock)
        {
                getsockname(sock, (sockaddr*)(&local), (socklen_t*)&iLen);
        }

        return AddressPortPair(local.sin_addr.s_addr, local.sin_port);
}

AddressPortPair GetPeerName(uint32_t sock)
{
        sockaddr_in peer;
        memset(&peer, 0, sizeof(peer));
        peer.sin_family = AF_INET;

        int iLen = sizeof(peer);
        u_int32_t uAddr = 0;
        u_int16_t uPort = 0;

        if (INVALID_SOCKET != sock)
        {
                getpeername(sock, (sockaddr*)(&peer), (socklen_t*)&iLen);
        }

        return AddressPortPair(peer.sin_addr.s_addr, peer.sin_port);
}

#if 0
int StringTokenizer(const std::string sToParse, const char* cToken, std::vector<std::string>& v){

char *str1, *str2, *token, *subtoken;
char *saveptr1, *saveptr2;
int j;

	char* szToParse = new char[sToParse.size()];
	memcpy(szToParse,sToParse.data(), sToParse.size());

	for (j = 1, str1 = szToParse; ; j++, str1 = NULL) {
		token = strtok_r(str1, cToken, &saveptr1);
		if (token == NULL){
			break;
		}

		for (str2 = token; ; str2 = NULL) {
			subtoken = strtok_r(str2, cToken, &saveptr2);
			if (subtoken == NULL)
				break;
			printf("Token: %s\n", subtoken);
			v.push_back(std::string(subtoken));
		}
	}

	delete [] szToParse;

return 0;
}
#endif

int StringTokenizer(const std::string sToParse, const char* cToken, std::vector<std::string>& v){

        size_t iStart = 0;

        while(1){

                size_t iPos = sToParse.find_first_of(cToken, iStart);
                if(iPos == std::string::npos){
                        break;
                }

                std::string s = sToParse.substr(iStart, iPos - iStart );
                v.push_back(s);

                iStart = iPos+1;
        }

        //test
#if 0
        for(int i=0;i<v.size();i++){
     //           std::cout<<v[i]<<std::endl;
        }
#endif

return 0;
}

std::string GetGMTime(void)
{
        // mm/dd/yyyy HH:MM:SS
        // 1234567891123456789
        char buf[50];

        time_t tNow = time(NULL);
        //strftime(buf, sizeof(buf), "%Y-%m-%d %T", ::localtime(&tNow));
        strftime(buf, sizeof(buf), "%Y-%m-%d %T", ::gmtime(&tNow));
        //strcpy(buf, asctime(gmtime(&tNow)));

        return buf;
}


std::string itoa(int i){

	std::stringstream ss;
	ss << i;

return ss.str();
}
