#include<stdio.h>
#include<signal.h>
#include<string.h>
#include<iostream>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

extern "C"{
#include "pgm_interface.h"
}

static bool bRun = true;
static void on_signal (
        int             signum
        )
{
        printf ("on_signal (signum:%d)\n", signum);
	close_pgm();
}


int GetFileSize(const std::string& sFile){
        struct stat fStat;
        stat( sFile.c_str(), &fStat );
        return fStat.st_size;

return -1;
}

int main(){

#if 0
        signal (SIGINT,  on_signal);
        signal (SIGTERM, on_signal);
#endif

//std::string sFileName("c.txt");
//std::string sFileLoc("/tmp/c.txt");
std::string sFileName("command.sh.1");
std::string sFileLoc("/home/rahman/project/test_clients/Terminal_1/command.sh.1");

if(!init_pgm())
	return -1;

create_send_transport("eth0;239.192.0.1",7500, 0, false);
create_recv_transport("eth0;239.192.0.1",7500, 0, false);

start_receiver_thread();

	int i;
	while(bRun){
		scanf("%d",&i);
		switch(i){
			case 0:
				close_pgm();
				bRun = false;
				break;
			case 1:
				send_packet("hello world", strlen("hello world"));
				break;
			case 2:
				send_file(sFileName.c_str(), sFileName.size(), sFileLoc.c_str(), sFileLoc.size(), GetFileSize(sFileLoc));
				break;
		}
	}

return 0;
}


