#ifndef UTIL_H
#define UTIL_H

#include<vector>

typedef std::pair<uint32_t, uint16_t> AddressPortPair;

int GetFileSize(const std::string& sFile);
std::string GetDotFormatIP(uint32_t ip);
void reuse(int fd);
void nonblock(int fd);
void nodelay(int fd);
void ByteOrderTesting();
int RunAsDaemon(const char* stdoutname);
int write_pid(const char * sFileName);

AddressPortPair GetSockName(uint32_t sock);
int StringTokenizer(const std::string sToParse, const char* cToken, std::vector<std::string>& v);






#endif//UTIL_H
